var pd = {
	index : 0,
	controls : {},
	control : function(type, id) {
		this.type = type;
		this.id = id;
		this.name = id;
		this.$container = null;
		this.$label = null;
		this.$li = null;
		this.labels = {};
		this.update = false;
	},
	loadPatch: function(patch){
		var controls = JSON.parse(patch.controls);
		// empty html
		pd.$displayPan.html('');
		pd.$controlEdit.html('');
		pd.$listPatchControls.html('');
		//add patch data
		pd['xmlId'] = patch.xmlId;
		pd.$patchName.val(patch.name);
		$.each(controls, function(i, v){
			var control = pd.controls[v.name] = new pd.control(v.type, v.name);
			control['update'] = true;
			switch(control.type){
				case "slider":
					control['min'] = v.min;					
					control['max'] = v.max;
					break;
				case "radio":
				case "checkbox":
					control['num'] = v.num;
					if(typeof v.labels != "undefined"){
						for(var i in v.labels)
						{
							control['labels'][i] = v.labels[i];			
						}
					}
					break;
			}
			pd.index++;
			control.displayControl(v.position);
			control.displayListItem();		
		})

	},
	createControl : function(selected) {
		this.index++;
		var id = 'control-' + this.index;
		this.controls[id] = new pd.control(selected, id);
		this.controls[id].createForm(false);
	},
	resetSelect : function() {
		this.$defaultSelected.attr('selected', 'selected');
//		this.$controlSelect.trigger('change'); // disable confirm button
	},
	removeControl : function(id) {
		if ($li = $('#li-' + id)) {
			$li.remove();
		}
		if ($container = $('#container-' + id)) {
			$container.remove();
		}
		this.$controlEdit.children().remove();
		delete this.controls[id];
		this.resetSelect();
	},
	sendMessage : function(name, value) {
		$.post('send.php', {data:{'name':name, 'value':value}}, function(response){
		}, 'json');
	},
	init : function() {
		this['$displayPan'] = $('#display-pan');
		this['$controlSelect'] = $("#control-select");
		this['$defaultSelected'] = $(pd.$controlSelect.children('option').get(0));
		this['$confirmSelected'] = $("#confirm-selected-btn");
		this['$controlEdit'] = $("#control-edit");
		this['$listPatchControls'] = $('#list-patch-controls');
		this['$listPatchChoice'] = $('#list-patch-choice');
		this['$patchName'] = $('#patch-name');
		
		//fetch patch list
		$.post('xml.php', {'query':'*'}, function(response){
			  if(response.type == "success"){
				  var str = '<option selected="selected" value="">select a patch</option>';
				  $.each(response.data, function(c, v){
					  str += '<option value="'+ v.patchId +'">'+ v.patchName +'</option>';
				  });
				  pd.$listPatchChoice.html('').append( $(str) ).change(function(){
					 var patchId =  pd.$listPatchChoice.val();
					 if(patchId == "") return;
					 $.post('xml.php', {'query': patchId }, function(response){
						 if(response.type == "success"){
							 pd.loadPatch(response.data);
						 }else{
							 alert('error : '+ response.message);
						 }
					 }, 'json');
				  }).show();
			  }
			}, 'json');
		
		this.$controlSelect.change(function() {
			var selected = this.value;
			if (selected != "") {
				// previous selected reference may be not null
//				pd.$confirmSelected.attr('disabled', '').unbind('click');
//				pd.$confirmSelected.bind('click', function() {
					pd.createControl(selected);
					pd.resetSelect();
//				});
			} 
//		    else {
//				pd.$confirmSelected.attr('disabled', 'disabled')
//						.unbind('click');
//			}
		});
		
		$('#save-patch-btn').click(function(){ pd.savePatch() });
		$('#remove-patch-btn').click(function(){ pd.deletePatch() });
	}, 
	isInt: function(x){
		   var y=parseInt(x); 
		   if (isNaN(y)) return false; 
		   return x==y && x.toString()==y.toString(); 
	},
	deletePatch: function(){
		if(typeof this.xmlId == "undefined") return false;
		$.post('xml.php', {'delete': pd.xmlId}, function(response){
			switch(response.type){
				case "success":
					alert('patch deleted');
					window.location.reload();
					break;
				case "failure":
					alert(response.message);
					break;
			}
		}, 'json');
	},
	savePatch: function(){
		var data = {controls : []};
		
		if(!pd.$displayPan.children().size() >0){
			alert('patch is empty');
			return false;
		}
		var patchName = pd.$patchName.val().trim();
		if(patchName == ""){
			alert('fill in patch name');
			return false;
		}

		for(var i in pd.controls){
			if(!pd.controls[i].$container) {
				delete pd.controls[i];
				continue;
			}
			var control = {
					'name' : pd.controls[i].name,
					'type' : pd.controls[i].type,
					'position' : {
						'top':pd.controls[i].$container.css('top'),
						'left':pd.controls[i].$container.css('left')
					}
			};
			//radio && checkbox
			switch(control.type){
				case "radio":
				case "checkbox":
					control['num'] = pd.controls[i].num;
					if(typeof pd.controls[i].labels[0] != "undefined"){
						control['labels'] = pd.controls[i].labels;
					}
					break;
				case "slider":
					control['min'] = pd.controls[i].min;
					control['max'] = pd.controls[i].max;		
					break;
			}
			data.controls.push(control);
		}

		data.controls = JSON.stringify(data.controls);
		data['name'] = patchName;
		if(typeof pd.xmlId != "undefined") data['xmlId'] = pd.xmlId;
		
		$.post('xml.php', {'data': data}, function(response){
			switch(response.type){			
				case "success":
					pd['xmlId'] = response.data.xmlId;
					alert('patch saved :)')
					break;
				case "failure":
					alert("failure saving patch");
					break;
			}
		}, 'json');
	}
}

pd.control.prototype.createForm = function() {
	var update = arguments[0] ? true : false;
	var self = this;
	this.createNameField();
	switch (this.type) {
		case "radio" :
		case "checkbox" :
			this.createChoiceManyFields();
			break;
		case "slider" :
			this.createSliderFields()
			break;
	}
	// save event
	var $save = $('<input class="left" id="save-' + this.id
			+ '" type="button" value="ok" />');
	$save.click(function() {
		self.save();
	});
	var $removeButton = $('<input class="left" id="remove-' + this.id
			+ '" type="button" value="remove"/>');
	$removeButton.click(function() {
		pd.removeControl(self.id);
	});
	pd.$controlEdit.append($save).append($removeButton).append('<div class="clear"></div>');

};

pd.control.prototype.createNameField = function() {
	var str = '<label for="' + this.id
			+ '">control name</label><input type="text" id="' + this.id
			+ '-name" value="' + this.id + '" />';
	pd.$controlEdit.html('').append($(str));
};

pd.control.prototype.createChoiceManyFields = function() {
	var self = this, id = this.id + '-num', oid = this.id + '-optin';

	var str = '<label for="' + id + '">' + this.type
			+ ' number</label><input type="text" id="' + id + '" value="3" />';
	pd.$controlEdit.append($(str));

	var $optin = $('<input type="checkbox" id="' + oid + '" />');
	$optin.click(function() {

		if (this.checked) {
			$('#' + self.id + '-num').attr('disabled', 'disabled');
			var val = $('#' + id).val();
			if (val != '' && self.num != val) pd.controls[self.id]['num'] = val;			
			self.createChoiceManyLabelFieldset();
		} else {
			$('#' + self.id + '-num').attr('disabled', '');
			pd.$controlEdit.children('fieldset').remove();
		}
	});
	pd.$controlEdit.append($optin);
}

pd.control.prototype.createSliderFields = function() {
	// min, max,
	var min = (typeof this.min !="undefined")? this.min : 0;
	var max = (typeof this.max !="undefined")? this.max : '';
	
	$control = $('<label for="' + this.id
			+ '-min">min</label><input type="text" id="' + this.id
			+ '-min" value="'+min+'"/><label for="' + this.id
			+ '-max">max</label><input type="text" id="' + this.id + '-max" value="'+max+'"/>');
	pd.$controlEdit.append($control);
};

pd.control.prototype.save = function() {
	var name = $('#' + this.id + '-name').val().trim(), // @todo trim
	self = this;
	// 1/3 : save object properties
	if (name == "") {
		alert('fill control name');
		return;
	}
	if (this.name != name) {
		this.name = name;
	}
	switch (this.type) {
		case "radio" :
		case "checkbox" :
			var num = $('#' + this.id + '-num').val().trim(),
				f = {};
			if (!pd.isInt( num.trim() ) ) {
				alert('fill ' + this.type + ' number');
				return;
			}
			if (this.num != num)
				this.num = parseInt(num);

			f = pd.$controlEdit.children('fieldset');
			if (f.size() > 0) {
				f.children('input').each(function(c, v) {				
					if ( v.value.trim() != "") {
						self.labels[c] = v.value;
					}
				});
			}else{ //we may want to clear previous labels
				if(typeof self.labels[0] != "undefined") self.labels = {};
			}
			break;
		case 'slider':
			var min = $('#' + this.id + '-min').val().trim(), 
				max = $('#' + this.id + '-max').val().trim();			
			if ( !pd.isInt(min) || !pd.isInt(max)) {
					alert('fill ' + this.type + ' min/max');
					return;
			}
			pd.controls[this.id]['min'] = parseInt(min);
			pd.controls[this.id]['max'] = parseInt(max);		
			break;
	}
	// 2/3 : display elements if needed
	if (!this.update) {
		this.update = true;		
		this.displayListItem();
		this.displayControl();
	}
	// 3/3 :update control properties
	else{
		// update elements name value
		switch (this.type) {
			case "radio":
			case "checkbox" :
				this.$label = this.$container.children().first();
				this.$container.children().remove();
				this.$container.append(this.$label);
				$control = this.createChoiceManyControl();
				this.$container.append($control);
				break;
			case 'slider':
				this.$control.slider('option', {'min':this.min, 'max':this.max});
				break;
		}
		this.$label.text(this.name);
		this.$li.text(this.name);
	}
}

pd.control.prototype.fillinForm = function() {
	switch (this.type) {
		case "text" :
		case "bang" :
		case "toggle" :
			$('#' + this.id + '-name').val(this.name);
			break
		case "radio" :
		case "checkbox" :
			$('#' + this.id + '-name').val(this.name);
			$('#' + this.id + '-num').val(this.num);
			break;
	}
};

pd.control.prototype.edit = function() {
	pd.$listPatchControls.children('li').removeClass('editing-li');
	this.$li.addClass('editing-li');
	this.createForm();
	this.fillinForm();
}

pd.control.prototype.displayListItem = function() {
	var self = this;
	this.$li = $('<li id="li-' + this.id + '">' + self.name + '</li>');
	this.$li.mouseover(function(){
		$(this).addClass('selected-li');
	}).mouseout(function(){
		$(this).removeClass('selected-li');
	});
	this.$li.click(function() {
		self.edit();
	});
	pd.$listPatchControls.append(this.$li);
}

pd.control.prototype.displayControl = function() {
	var self = this,
		$control = {};

	this.$container = $('<div id="container-' + this.id
			+ '" class="ui-widget left"></div>');
	this.$label = $('<div class="control-header">' + this.name + '</div>');
	this.$container.append(this.$label);

	switch (this.type) {
		case "text" :
			$control = $('<input type="text" id="' + this.id + '" />');
			var $send = $('<input id="send-' + this.id
					+ '" type="button" value="send" />');
			$send.click(function() {
				if($control.val().trim() != '') pd.sendMessage(self.name, $control.val());
			});
			var append = function() {
				self.$container.append($send);
			};
			break;
		case "bang" :
			$control = $('<input name="' + this.name
					+ '" type="button" value="1" id="' + this.id + '" />');
			$control.click(function() {
				pd.sendMessage(self.name, $control.val());
			});
			break;
		case "radio" :
		case "checkbox" :
			$control = this.createChoiceManyControl();
			break;
		case "toggle" :			
			$control = $('<input name="' + this.name
					+ '" type="checkbox" value="" id="' + this.id + '" />');
			$control.click(function() {
				pd.sendMessage(self.name,$control.get(0).checked ? 1: 0 );
			});
			break;
		case "slider":
			$control = $('<div id="'+this.id+'"></div>');
			var append = function(){
				pd.controls[self.id]['$sliderValue'] = $('<div id="'+self.id+'-slider-value" class="slider-value">'+self.min+'</div>'); 
				$control.append(pd.controls[self.id]['$sliderValue']);				
				$control.slider({
					orientation:'vertical', 
					value:parseInt(self.min),  
					min:parseInt(self.min), 
					max: parseInt(self.max),
					slide: function(e, ui){
					    self.$sliderValue.text(ui.value);
						pd.sendMessage(self.name, ui.value);						
					}
				});
				// keep a reference of control to set updated value
				pd.controls[self.id]['$control'] = $control;
			}
			break;
	}
	if(arguments[0]){
		this.$container.css({'top': arguments[0].top, 'left': arguments[0].left});
	}
	this.$container.append($control);
	if (append) {
		append();
	}
	pd.$displayPan.append(this.$container);
	this.$container.draggable({ containment: 'window' });
};

pd.control.prototype.createChoiceManyControl = function() {
	var self = this;
	var str = "";
	$control = {};
	for ( var i = 0; i < this.num; i++) {
		var lbl = (typeof this.labels[i] != "undefined") ? this.labels[i] : i;
		str += '<label for="' + this.id + '-' + i + '"><input id="' + this.id
				+ '-' + i + '" type="' + this.type + '" name="' + this.id
				+ '[]" value="'+lbl+'"/>' + lbl + '</label>';
	}
	$control = $(str);
	$control.children('input').click(function() {
		$this = $(this);
		switch(self.type){
			case "checkbox":				
			case "radio":
					pd.sendMessage(self.name, $this.val() );
				break;
		}
	});
	return $control;
};

pd.control.prototype.createChoiceManyLabelFieldset = function() {
	var $fieldset = $('<fieldset></fieldset>')
	str = '';
	for ( var i = 0; i < this.num; i++) {
		var label = (typeof this.labels[i] != "undefined")? this.labels[i] : i;  
		str += '<input type="text" id="label-' + i + '" value="'+label+'"/>';
	}
	$fieldset.append($(str));
	$fieldset.insertAfter($('#' + this.id + '-optin'));
};

$(document).ready(function() {
	pd.init();
});
