<?php

// we check incoming request
if(!count($_POST)>0
&& ( empty($_POST['query']) && empty($_POST['data']) && empty($_POST['delete']) ) )
{
	return false;
}

// assume request is ok
// create new DOMDocument object
$doc = new DOMDocument();
$doc->load('patches.xml');
//create xpath instance
$xpath = new DOMXPath($doc);

// we have to save patch data
if(!empty($_POST['data'])){

	$data = $_POST['data'];
	if(!is_array($data)) false;

	// not a new patch, try to retrieve it
	if(!empty($data['xmlId'])){
		$patchId = $data['xmlId'];
		$patch = $xpath->query('//patch[@id="'.$patchId.'"]')->item(0);
		if(is_null($patch->tagName)){
			print json_encode(array("type"=>"failure", "message"=> "no patch found"));
			return;
		}else{
			if($data['name'] != $patch->getAttribute('name')){
					$patch->setAttribute('name', $data['name']);
			}			
			if($data['controls'] != $patch->nodeValue){
				$patch->nodeValue = stripslashes($data['controls']);
			}
		}
	}
	// create a new patch
	else{
		$root = $xpath->query('//patches')->item(0);
		$patch = $doc->createElement('patch');
		$patch->setAttribute('name',$data['name']);
		$patch->setAttribute('id', uniqid());
		$controls = $doc->createTextNode(stripslashes($data['controls']));
		$patch->appendChild($controls);
		$root->appendChild($patch);
	}

	if(!$doc->save('patches.xml')){
		print json_encode(array("type"=>"failure", "message"=> "failure saving patch"));
		return;
	}
	else{
		print json_encode(array(
	 			"type"=>"success", 
	 			"data"=>array(
								"name" => $patch->getAttribute("name"),
	 					"xmlId"=> $patch->getAttribute("id")
		)));
		return;
	}

}
// assume we have a query request for one or more patch
elseif(!empty($_POST['query'])){
	$patchId = $_POST['query'];
	// we want a list of current  patches
	if($patchId =="*"){
		$patches = $xpath->query('//patch');
		$list = array();
		foreach($patches as $patch)
		{
			$list[] = array(
				 		'patchId'=> $patch->getAttribute('id'),
				 		'patchName'=> $patch->getAttribute('name')
			);
		}
		if(count($list)>0){
			print json_encode(array("type"=>"success", "data"=>$list));
		}else{
			print json_encode(array("type"=>"failure", "message"=>"no patch found"));
		}
	}
	//we just want one patch
	else{
		$patch = $xpath->query('//patch[@id="'.$patchId.'"]')->item(0);
		if(is_null($patch->tagName)){
			print json_encode(array("type"=>"failure", "message"=> "no patch found"));
		}else{
			print json_encode(array(
			"type"=>"success",
		 "data"=>array(
			   'xmlId'   => $patch->getAttribute('id'),
						'name'     => $patch->getAttribute('name'),
						'controls' => $patch->textContent
				)));
		}
	}
}
// delete patch
elseif(!empty($_POST['delete'])){
		$patchId = $_POST['delete'];
		$patch = $xpath->query('//patch[@id="'.$patchId.'"]')->item(0);
		$patches = $doc->documentElement;
		if(is_null($patch->tagName)){
			print json_encode(array("type"=>"failure", "message"=> "no patch found"));
			return;
		}else{
			 	 $patches->removeChild($patch);
			  $doc->save('patches.xml');
		   print json_encode(array("type"=>"success"));
		}
}
//script ends here
